--This is a special check file to help with the merging of XGUI into the ULX svn.
--Determines whether or not two copies of XGUI are currently installed.


--Some code (un)knowingly taken from ulx debuginfo :P
--We're checking for addons based on file existing since the users can name the addon folders to whatever they'd like.
local possibleaddons = file.FindDir( "../addons/*" )
for _, addon in ipairs( possibleaddons ) do
	if file.Exists( "../addons/" .. addon .. "/info.txt" ) then --Makes sure it's a properly working addon
		if  file.Exists( "../addons/" .. addon .. "/lua/ulx/modules/xgui_server.lua" ) and --Makes sure it has the main XGUI file
		not file.Exists( "../addons/" .. addon .. "/lua/ulx/base.lua" ) then --Makes sure the addon we detected ISN'T ULX.
			local function xgui_warning()
				Msg( "\n*******************************************************\n" )
				Msg( "* XGUI WARNING!!\n" )
				Msg( "* The latest ULX SVN now includes XGUI by default!\n" )
				Msg( "* XGUI has detected an additional copy of itself\n" )
				Msg( "* installed in your server's addons/" .. addon .. "/ folder!\n" )
				Msg( "* In order to ensure the proper functionality of XGUI,\n" )
				Msg( "* you must remove that copy of XGUI as soon as possible!\n" )
				Msg( "*******************************************************\n\n" )
			end
			hook.Add( "InitPostEntity", "xgui_warning_hook", xgui_warning )
			local function xgui_warning_send_admin_message( ply )
				if ply:query( "xgui_managegroups" ) then --Hopefully the owner or someone who knows the owner has access to this :P
					--Delay for 5 seconds to give time to allow the admin to join and get to a position where he can see the message.
					timer.Simple( 5, function()
						RunConsoleCommand( "ulx", "asay", "***XGUI Warning!!: XGUI has now been included by default with the latest ULX SVN. An older addon-based " ..
						"XGUI has been detected that needs to be removed! Please check your server log for more information and, if needed, inform your server owner." ) end )
				end
			end
			hook.Add( "ULibLocalPlayerReady", "xgui_warning_sendmessage", xgui_warning_send_admin_message )
		end
	end
end