--XGUI settings module for ULX GUI -- by Stickly Man!
--A settings module for modifing XGUI-based settings.

local xgui_settings = xlib.makepanel{ parent=xgui.null }
xlib.makebutton{ x=10, y=10, w=150, label="Refresh XGUI Modules", parent=xgui_settings }.DoClick=function()
	xgui.processModules()
end
xlib.makebutton{ x=10, y=30, w=150, label="Refresh Server Data", parent=xgui_settings }.DoClick=function( self )
	if xgui.isInstalled then  --We can't be in offline mode to do this
		self:SetDisabled( true )
		RunConsoleCommand( "xgui", "refreshdata" )
		timer.Simple( 30, function() self:SetDisabled( false ) end )
	end
end
xlib.makeslider{ x=10, y=55, w=150, label="Anim transition time", max=2, value=xgui.settings.animTime, decimal=2, parent=xgui_settings, textcolor=color_black }.OnValueChanged = function( self, val )
	local testval = math.Clamp( tonumber( val ), 0, 2 )
	if testval ~= tonumber( val ) then self:SetValue( testval ) end
	xgui.settings.animTime = tonumber( val )
end
xlib.makecheckbox{ x=10, y=97, w=150, label="Show Startup Messages", value=xgui.settings.showLoadMsgs, parent=xgui_settings, textcolor=color_black }.OnChange = function( self, bVal )
	xgui.settings.showLoadMsgs = bVal
end
xlib.makelabel{ x=10, y=117, label="Infobar color:", textcolor=color_black, parent=xgui_settings }

xlib.makecolorpicker{ x=10, y=135, color=xgui.settings.infoColor, addalpha=true, parent=xgui_settings }.OnChangeImmediate = function( self, color )
	xgui.settings.infoColor = color
end
xlib.makebutton{ x=10, y=295, w=150, label="Save Clientside Settings", parent=xgui_settings }.DoClick=function()
	xgui.saveClientSettings()
end

----------------
--SKIN MANAGER--
----------------
--Include the extra skins in case nothing else has included them.
for _, file in ipairs( file.FindInLua( "skins/*.lua" ) ) do
	include( "skins/" .. file )
end
xlib.makelabel{ x=10, y=253, label="Derma Theme:", textcolor=color_black, parent=xgui_settings }
xgui_settings.skinselect = xlib.makemultichoice{ x=10, y=270, w=150, parent=xgui_settings }
if not derma.SkinList[xgui.settings.skin] then
	xgui.settings.skin = "Default"
	xgui_settings.skinselect:SetText( derma.SkinList.Default.PrintName )
else
	xgui_settings.skinselect:SetText( derma.SkinList[xgui.settings.skin].PrintName )
end
xgui.base.refreshSkin = true
xgui_settings.skinselect.OnSelect = function( self, index, value, data )
	xgui.settings.skin = data
	xgui.base:SetSkin( data )
end
for skin, skindata in pairs( derma.SkinList ) do
	xgui_settings.skinselect:AddChoice( skindata.PrintName, skin )
end

xgui.addSettingModule( "XGUI", xgui_settings, "gui/silkicons/page_white_wrench" )